
Const FPS=90


Graphics3D 800,600,0,2
SetBuffer BackBuffer()

WireFrame False

camera = CreateCamera()
PositionEntity camera,0,10,-50

TOKSIM_SetRigidBodiesCount 300
TOKSIM_SetAnimatedBodiesCount 5
TOKSIM_SetGeometriesCount 305
TOKSIM_SetOverlappedPairsCount (305*(304))/2

TOKSIM_CreateSimulator(0,-10,0)

ground = CreateCube()
EntityColor ground,5,5,55 
ScaleEntity ground,50,5,50 
PositionEntity ground,0,-5,0
abground = TOKAB_Create()
TOKAB_AddBox(abground,100.0,10.0,100.0)
TOKAB_SetPosition(abground,0.0,-5.0,0.0)

wall1 = CreateCube()
EntityColor wall1,25,25,55 
ScaleEntity wall1,2,10,50 
PositionEntity wall1,50,0,0
abwall1 = TOKAB_Create()
TOKAB_AddBox(abwall1,4.0,20.0,100.0)
TOKAB_SetPosition(abwall1,50.0,0,0.0)

wall2 = CreateCube()
EntityColor wall2,25,25,55 
ScaleEntity wall2,2,10,50 
PositionEntity wall2,-50,0,0
abwall2 = TOKAB_Create()
TOKAB_AddBox(abwall2,4.0,20.0,100.0)
TOKAB_SetPosition(abwall2,-50.0,0,0.0)

wall3 = CreateCube()
EntityColor wall3,25,25,55 
ScaleEntity wall3,50,10,2 
PositionEntity wall3,0,0,-50
abwall3 = TOKAB_Create()
TOKAB_AddBox(abwall3,100.0,20.0,4.0)
TOKAB_SetPosition(abwall3,0.0,0,-50.0)

wall4 = CreateCube()
EntityColor wall4,25,25,55 
ScaleEntity wall4,50,10,2 
PositionEntity wall4,0,0,50
abwall4 = TOKAB_Create()
TOKAB_AddBox(abwall4,100.0,20.0,4.0)
TOKAB_SetPosition(abwall4,0.0,0,50.0)

Convex = CreateBank(962)
filein = ReadFile("rock.Bin")
For i=0 To 961
 PokeByte Convex,i,ReadByte(filein) 
Next   
CloseFile filein 

Dim obj(300)
Dim rb(300)


meshobj = LoadMesh("rock.x")

SeedRnd MilliSecs()  

For i=1 To 100
rot#=rot#+8.2
x#=Cos(rot)*20
z#=Sin(rot)*20

 nr=Rnd(2,3)		
 If nr=2 Then
  obj(i) = CreateCube()
  ScaleEntity obj(i),1,0.5,0.5 
  rb(i) = TOKRB_Create()
  geom = TOKRB_AddBox(rb(i),2.0,1.0,1.0)
  TOKGEOM_SetMaterialIndex geom,1 
  TOKRB_SetPosition rb(i),x#,2+i*0.2,z#
  TOKRB_SetLinearDamping rb(i),0.001
  TOKRB_SetAngularDamping rb(i),0.001	
  TOKRB_SetMass rb(i),2.0
  TOKRB_SetBoxInertiaTensor rb(i),2.0,1.0,1.0,2.0  
  EntityColor obj(i),Rnd(100,230),Rnd(100,230),Rnd(100,230) 

 ElseIf nr=1 
  obj(i) = CreateSphere()
  rb(i) = TOKRB_Create()
  TOKRB_AddSphere rb(i),2
  TOKRB_SetPosition rb(i),x#,2+i*0.2,z#
  TOKRB_SetAngularDamping rb(i),0.002
  TOKRB_SetLinearDamping rb(i),0.001 
  TOKRB_SetMass rb(i),2.0
  TOKRB_SetSphereInertiaTensor rb(i),2,2.0 
  EntityColor obj(i),Rnd(100,230),Rnd(100,230),Rnd(100,230) 

 ElseIf nr=3 
  obj(i) = CopyMesh(meshobj)
  rb(i) = TOKRB_Create()
  TOKRB_AddConvex(rb(i),Convex,BankSize(Convex))
  TOKRB_SetPosition(rb(i),x#,22+i*0.2,z#)
  TOKRB_SetAngularDamping rb(i),0.002 
  TOKRB_SetLinearDamping rb(i),0.001 
  TOKRB_SetMass rb(i),2.0
  TOKRB_SetSphereInertiaTensor rb(i),1.0,2.0  
  EntityColor obj(i),Rnd(100,230),Rnd(100,230),Rnd(100,230) 
 EndIf


Next

FreeEntity meshobj  

Centerpivot = CreatePivot()

light=CreateLight()
PositionEntity light,7,15,-5
PointEntity light,Centerpivot

rot#=0

period=1000/FPS
time=MilliSecs()-period

imptime=MilliSecs()
; MainLoop
While Not KeyHit(1)

	Repeat
		elapsed=MilliSecs()-time
	Until elapsed

	ticks=elapsed/period
	tween#=Float(elapsed Mod period)/Float(period)

	For k=1 To ticks
		time=time+period
		If k=ticks Then CaptureWorld

		TOKSIM_Advance(1.5/FPS,1)
		
camx#=Cos(rot#)*20
camz#=Sin(rot#)*20


If rot#>360 Then rot#=0

PositionEntity camera,camx#,20,camz#
PointEntity camera,centerpivot  
For i=1 To 100
 PositionEntity obj(i),TOKRB_GetX#(rb(i)),TOKRB_GetY#(rb(i)),TOKRB_GetZ#(rb(i)) 
 RotateEntity obj(i),TOKRB_GetPitch#(rb(i)),TOKRB_GetYaw#(rb(i)),TOKRB_GetRoll#(rb(i)),False
Next
	UpdateWorld

	Next


If KeyHit(57) Then
 For i=1 To 100
  TOKRB_ApplyImpulse rb(i),0,25,0
 Next
EndIf


RenderWorld tween

Text 0,10,"Render Time:"+Str(elapsed)+ " milliseconds"
	Flip

Wend

TOKSIM_DestroySimulator()

End