// TokamakDLL.cpp : Defines the entry point for the DLL application.
//

#include "TokamakDLL.h"
#include "Tokamak.h"

#pragma comment(lib, "tokamakdll.lib")

#define TESTDLL_API extern "C" __declspec(dllexport)

void AddSensorToBuffer(neSensor * Sensor);
void AddSensorDataToBuffer(neSensor * Sensor);
void RemoveSensorFromBuffer(neSensor * Sensor);
bool ReadConvexData(char * filename, neByte *& adjacency);
bool ReadConvexData2(neByte *Bank,int BankSize, neByte *& adjacency);


class MyRigidBodyControllerCallback : public neRigidBodyControllerCallback
{
public:
   virtual void RigidBodyControllerCallback(neRigidBodyController * controller,float timestep) 
    {
	//Check if the rigidbody has sensors attached
	//If it does, fetch sensor info and pass it to the sensor associated memorybank
	neSensor * tempsensor;
	neRigidBody * CurrentBody;
	CurrentBody = controller->GetRigidBody();

	CurrentBody->BeginIterateSensor();
	while (tempsensor = CurrentBody->GetNextSensor())
	{
		AddSensorDataToBuffer(tempsensor);
	};

	};
};


neSimulator *gSim = NULL;
neSimulatorSizeInfo sizeInfo;
nePerformanceReport perfReport;
MyRigidBodyControllerCallback rbcallbackInstance;
void * SensorBuffer; 

int CollisionCount;
neCollisionInfo *CTablePointer;
int *BankPtr1;
float *BankPtr2;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

neV3 Mat3ToEulerZXY(neM3 Matrix); // This is for Blitz3D
neM3 EulerToMat3(float Pitch,float Yaw,float Roll); // This is for Blitz3D

// *************
// * SIMULATOR *
// *************

TESTDLL_API void __stdcall TOKSIM_SetRigidBodiesCount(int Count)
{	sizeInfo.rigidBodiesCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetAnimatedBodiesCount(int Count)
{	sizeInfo.animatedBodiesCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetRigidParticleCount(int Count)
{	sizeInfo.rigidParticleCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetControllersCount(int Count)
{	sizeInfo.controllersCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetOverlappedPairsCount(int Count)
{	sizeInfo.overlappedPairsCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetGeometriesCount(int Count)
{	sizeInfo.geometriesCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetConstraintsCount(int Count)
{	sizeInfo.constraintsCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetConstraintSetsCount(int Count)
{	sizeInfo.constraintSetsCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetConstraintBufferSize(int Count)
{	sizeInfo.constraintBufferSize = Count; }
TESTDLL_API void __stdcall TOKSIM_SetSensorsCount(int Count)
{	sizeInfo.sensorsCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetStaticMeshNodesStartCount(int Count)
{	sizeInfo.terrainNodesStartCount = Count; }
TESTDLL_API void __stdcall TOKSIM_SetStaticMeshNodesGrowByCount(int Count)
{	sizeInfo.terrainNodesGrowByCount = Count; }


TESTDLL_API void __stdcall TOKSIM_SetCInfoBank(neCollisionInfo *CInfoBank)
{
	CTablePointer = CInfoBank;
}


void myCallBack(neCollisionInfo & cInfo)
{
	if (CTablePointer)
	{

	*BankPtr1 = (int)(cInfo.bodyA);
	BankPtr1+= 1;
	*BankPtr1 = (int)(cInfo.bodyB);
	BankPtr1+= 1;
	*BankPtr1 = (int)(cInfo.typeA);
	BankPtr1+= 1;
	*BankPtr1 = (int)(cInfo.typeB);
	BankPtr1+= 1;
	*BankPtr1 = (int)(cInfo.geometryA);
	BankPtr1+= 1;
	*BankPtr1 = (int)(cInfo.geometryB);
	BankPtr1+= 1;
	*BankPtr1 = (int)(cInfo.materialIdA);
	BankPtr1+= 1;
	*BankPtr1 = (int)(cInfo.materialIdB);
	BankPtr1+= 1;
	
	// Fetch the floats
	BankPtr2=(float *)BankPtr1;
	*BankPtr2 = (float)(cInfo.bodyContactPointA.v[0]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.bodyContactPointA.v[1]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.bodyContactPointA.v[2]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.bodyContactPointB.v[0]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.bodyContactPointB.v[1]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.bodyContactPointB.v[2]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.worldContactPointA.v[0]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.worldContactPointA.v[1]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.worldContactPointA.v[2]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.worldContactPointB.v[0]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.worldContactPointB.v[1]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.worldContactPointB.v[2]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.relativeVelocity.v[0]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.relativeVelocity.v[1]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.relativeVelocity.v[2]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.collisionNormal.v[0]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.collisionNormal.v[1]);
	BankPtr2+= 1;
	*BankPtr2 = (float)(cInfo.collisionNormal.v[2]);
	BankPtr2+= 1;
	BankPtr1=(int *)BankPtr2;


	CollisionCount+=1;
	}

}

TESTDLL_API void __stdcall TOKSIM_SetCollisionResponse(int CollisionID1, int CollisionID2,int Response)
{
	neCollisionTable *CT;
	neCollisionTable::neReponseBitFlag Resp;
	Resp = (neCollisionTable::neReponseBitFlag)Response;

	CT = gSim->GetCollisionTable();
	CT->Set(CollisionID1,CollisionID2,Resp);
	// Do it reversed as well to work around a known bug
	CT->Set(CollisionID2,CollisionID1,Resp);
}

TESTDLL_API int __stdcall TOKSIM_GetCollisionCount()
{
	return CollisionCount;
}





TESTDLL_API int __stdcall TOKSIM_CreateSimulator(float GravX,float GravY,float GravZ)
{
	neV3 gravity;
	int i;
	int * intptr;
//	float * floatptr;


//	sizeInfo.rigidBodiesCount = RigidBodyCount;
//	sizeInfo.animatedBodiesCount = AnimBodyCount;
//	s32 totalBody = sizeInfo.rigidBodiesCount + sizeInfo.animatedBodiesCount;
//	sizeInfo.overlappedPairsCount = totalBody * (totalBody - 1) / 2;
//	sizeInfo.geometriesCount = totalBody;
//	sizeInfo.rigidParticleCount = 0;
//	sizeInfo.terrainNodesStartCount = 0;
//	sizeInfo.controllersCount = 1;

	gravity.Set(GravX, GravY, GravZ);

	gSim = neSimulator::CreateSimulator(sizeInfo, NULL, &gravity);

	perfReport.Reset();
	perfReport.SetReportType(nePerformanceReport::NE_PERF_RUNNING_AVERAGE);

	gSim->SetCollisionCallback(myCallBack);
	if(sizeInfo.sensorsCount>0)
	{
		SensorBuffer = malloc(sizeInfo.sensorsCount*44);
		intptr = (int *)SensorBuffer;
		for(i=0;i<sizeInfo.sensorsCount*11;i++)
		{
			*intptr=0;
			intptr+=1;
		};
	};

	if (gSim) {
		return 1;
	}
	else {
		return 0;
	}
}

TESTDLL_API void __stdcall TOKSIM_DestroySimulator(void)
{
	if (gSim)
	{
		if(SensorBuffer)
			free(SensorBuffer);

		neSimulator::DestroySimulator(gSim);
		gSim = NULL;
	}
}

TESTDLL_API void __stdcall TOKSIM_Advance(float Elapsedtime,int SubSteps)
{
	if (gSim)
	{
		if (CTablePointer)
		{
			CollisionCount=0;
			BankPtr1 = (int *)CTablePointer;
		}

		gSim->Advance(Elapsedtime,SubSteps,&perfReport);
	}

}

TESTDLL_API void __stdcall TOKSIM_Advance2(float Elapsedtime, float minTimeStep, float maxTimeStep)
{
	if (gSim)
	{
		if (CTablePointer)
		{
			CollisionCount=0;
			BankPtr1 = (int *)CTablePointer;
		}

        gSim->Advance(Elapsedtime,minTimeStep,maxTimeStep,&perfReport);
	}

}

TESTDLL_API float __stdcall TOKSIM_GetPhysicsTime()
{
		return perfReport.time[nePerformanceReport::NE_PERF_TOTAL_TIME];
}


//bool SetMaterial(s32 index, f32 friction, f32 restitution);
//bool GetMaterial(s32 index, f32& friction, f32& restitution);

TESTDLL_API void __stdcall TOKSIM_SetMaterial(int Index,float Friction,float Restitution)
{
	if (gSim)
	{
		gSim->SetMaterial(Index,Friction,Restitution);
	}
}

TESTDLL_API float __stdcall TOKSIM_GetMaterialFriction(int Index)
{
	f32 friction;
	f32 restitution;
	if (gSim)
	{
		gSim->GetMaterial(Index,friction,restitution);
		return friction;
	}
		return 0.0f;
}

TESTDLL_API float __stdcall TOKSIM_GetMaterialRestitution(int Index)
{
	f32 friction;
	f32 restitution;
	if (gSim)
	{
		gSim->GetMaterial(Index,friction,restitution);
		return restitution;
	}
		return 0.0f;
}

TESTDLL_API void __stdcall TOKSIM_SetGravity(float X,float Y, float Z)
{
	neV3 Gravity;
	if (gSim)
	{
		Gravity.v[0] = X;
		Gravity.v[1] = Y;
		Gravity.v[2] = Z;

		gSim->Gravity(Gravity);
	}
}

TESTDLL_API float __stdcall TOKSIM_GravityX()
{
	if (gSim)
	{
		return gSim->Gravity().v[0];
	}
	return 0.0f;
}

TESTDLL_API float __stdcall TOKSIM_GravityY()
{
	if (gSim)
	{
		return gSim->Gravity().v[1];
	}
	return 0.0f;
}

TESTDLL_API float __stdcall TOKSIM_GravityZ()
{
	if (gSim)
	{
		return gSim->Gravity().v[2];
	}
	return 0.0f;
}

	//neV3 Gravity();
	//void Gravity(const neV3 & gravity);


// **************
// * RIGID BODY *
// **************

TESTDLL_API neRigidBody * __stdcall TOKRB_Create()
{
	neRigidBody *NewRigidBody;

	if (gSim)
	{
		NewRigidBody = gSim->CreateRigidBody();

		return NewRigidBody;
	}
	else 
	{
		return 0;
	}
}

TESTDLL_API void __stdcall TOKRB_Free(neRigidBody *RigidBody)
{

	if (RigidBody)
	{
	// First remove all connected sensors
	neSensor * tempsensor;
	RigidBody->BeginIterateSensor();
	while (tempsensor = RigidBody->GetNextSensor())
	{
		RemoveSensorFromBuffer(tempsensor);	
	};

		gSim->FreeRigidBody(RigidBody);
	}
}

TESTDLL_API void __stdcall TOKRB_SetCollisionID(neRigidBody *RigidBody,int ColID)
{
	if (RigidBody)
	{
		RigidBody->SetCollisionID(ColID);
	}
}

TESTDLL_API int __stdcall TOKRB_GetCollisionID(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		return RigidBody->GetCollisionID();
	}
		return 0;	
}

TESTDLL_API neGeometry * __stdcall TOKRB_AddBox(neRigidBody *RigidBody,float Width,float Height,float Depth)
{
	neGeometry *geom;

	if (gSim)
	{
		geom = RigidBody->AddGeometry();
		geom->SetBoxSize(Width, Height, Depth);
		RigidBody->UpdateBoundingInfo();
		return geom;
	}
	else 
	{
		return 0;
	}
}

TESTDLL_API neGeometry * __stdcall TOKRB_AddSphere(neRigidBody *RigidBody,float Diameter)
{
	neGeometry *geom;

	if (gSim)
	{
		geom = RigidBody->AddGeometry();
		geom->SetSphereDiameter(Diameter);
		RigidBody->UpdateBoundingInfo();
		return geom;
	}
	else 
	{
		return 0;
	}
}

TESTDLL_API neGeometry * __stdcall TOKRB_AddCylinder(neRigidBody *RigidBody,float Diameter,float Height)
{
	neGeometry *geom;	

	if (RigidBody)
	{
		geom = RigidBody->AddGeometry();
		geom->SetCylinder(Diameter, Height);
		RigidBody->UpdateBoundingInfo();
		return geom;
	}
	else 
	{
		return 0;
	}
}

TESTDLL_API neGeometry * __stdcall TOKRB_AddConvex(neRigidBody *RigidBody,neByte *Bank,int BankSize)
{
	neGeometry *geom;	
	neByte *NeighbourData;
	
	if (RigidBody)
	{
		ReadConvexData2(Bank,BankSize, NeighbourData);
		geom = RigidBody->AddGeometry();
		geom->SetConvexMesh(NeighbourData);
		RigidBody->UpdateBoundingInfo();
		return geom;
	}
	else 
	{
		return 0;
	}
}


//void	SetConvexMesh(neByte * convexData);


TESTDLL_API int __stdcall TOKRB_GetGeometryCount(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		return RigidBody->GetGeometryCount();
	}
	return 0;
}

TESTDLL_API void __stdcall TOKRB_RemoveGeometry(neRigidBody *RigidBody,neGeometry *Geom)
{
	if (RigidBody)
	{
		if (Geom)
		{
			RigidBody->RemoveGeometry(Geom);
		}
	}
}


TESTDLL_API void __stdcall TOKRB_BeginIterateGeometry(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		RigidBody->BeginIterateGeometry();
	}
}

TESTDLL_API neGeometry * __stdcall TOKRB_GetNextGeometry(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		return RigidBody->GetNextGeometry();
	}
	return 0;
}


TESTDLL_API void __stdcall TOKRB_UpdateBoundingInfo(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		RigidBody->UpdateBoundingInfo();
	}
}

TESTDLL_API void __stdcall TOKRB_UpdateInertiaTensor(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		RigidBody->UpdateInertiaTensor();
	}
}


TESTDLL_API void __stdcall TOKRB_SetMass(neRigidBody *RigidBody,float Mass)
{

	if (RigidBody)
	{
		RigidBody->SetMass(Mass);
	}
}

TESTDLL_API void __stdcall TOKRB_SetBoxInertiaTensor(neRigidBody *RigidBody,float Width,float Height,float Depth,float Mass)
{

	if (RigidBody)
	{
		RigidBody->SetInertiaTensor(neBoxInertiaTensor(Width, Height, Depth, Mass));
	}
}


TESTDLL_API void __stdcall TOKRB_SetSphereInertiaTensor(neRigidBody *RigidBody,float Diameter,float Mass)
{

	if (RigidBody)
	{
		RigidBody->SetInertiaTensor(neSphereInertiaTensor(Diameter, Mass));
	}
}

TESTDLL_API void __stdcall TOKRB_SetCylinderInertiaTensor(neRigidBody *RigidBody,float Diameter,float Height,float Mass)
{

	if (RigidBody)
	{
		RigidBody->SetInertiaTensor(neCylinderInertiaTensor(Diameter, Height, Mass));
	}
}

TESTDLL_API void __stdcall TOKRB_SetPosition(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 pos;
	if (RigidBody)
	{
		pos.Set(X , Y , Z);
		RigidBody->SetPos(pos);
	}
}

TESTDLL_API float __stdcall TOKRB_GetX(neRigidBody *RigidBody)
{
	neV3 BodyPos;

	if (RigidBody)
	{
		BodyPos = RigidBody->GetPos();
	}
	return BodyPos.v[0];
}

TESTDLL_API float __stdcall TOKRB_GetY(neRigidBody *RigidBody)
{
	neV3 BodyPos;

	if (RigidBody)
	{
		BodyPos = RigidBody->GetPos();
	}
	return BodyPos.v[1];
}

TESTDLL_API float __stdcall TOKRB_GetZ(neRigidBody *RigidBody)
{
	neV3 BodyPos;

	if (RigidBody)
	{
		BodyPos = RigidBody->GetPos();
	}
	return BodyPos.v[2];
}

TESTDLL_API void __stdcall TOKRB_SetRotation(neRigidBody *RigidBody,float Pitch,float Yaw,float Roll)
{
	neM3 BodyRot;
	if (RigidBody)
	{
		BodyRot = EulerToMat3(Pitch,Yaw,Roll);
		RigidBody->SetRotation(BodyRot);
	}
}

TESTDLL_API float __stdcall TOKRB_GetPitch(neRigidBody *RigidBody)
{
	neV3 Euler;
	Euler = Mat3ToEulerZXY(RigidBody->GetRotationM3());
	return -NE_RAD_TO_DEG(Euler.v[0]);
}
TESTDLL_API float __stdcall TOKRB_GetYaw(neRigidBody *RigidBody)
{
	neV3 Euler;
	Euler = Mat3ToEulerZXY(RigidBody->GetRotationM3());
	return NE_RAD_TO_DEG(Euler.v[1]);
}
TESTDLL_API float __stdcall TOKRB_GetRoll(neRigidBody *RigidBody)
{
	neV3 Euler;
	Euler = Mat3ToEulerZXY(RigidBody->GetRotationM3());
	return -NE_RAD_TO_DEG(Euler.v[2]);
}


TESTDLL_API void __stdcall TOKRB_ApplyImpulse(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Impulse;
	Impulse.v[0]=X;
	Impulse.v[1]=Y;
	Impulse.v[2]=Z;
	
	RigidBody->ApplyImpulse(Impulse);
}

TESTDLL_API void __stdcall TOKRB_ApplyImpulse2(neRigidBody *RigidBody,float X,float Y,float Z,float XPos,float YPos,float ZPos)
{
	neV3 Impulse;
	neV3 Pos;

	Impulse.v[0]=X;
	Impulse.v[1]=Y;
	Impulse.v[2]=Z;
	Pos.v[0]=XPos;
	Pos.v[1]=YPos;
	Pos.v[2]=ZPos;
	
	RigidBody->ApplyImpulse(Impulse,Pos);
}


TESTDLL_API void __stdcall TOKRB_ApplyTwist(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Twist;
	Twist.v[0]=X;
	Twist.v[1]=Y;
	Twist.v[2]=Z;
	
	RigidBody->ApplyTwist(Twist);
}

TESTDLL_API void __stdcall TOKRB_SetForce(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Force;
	Force.v[0]=X;
	Force.v[1]=Y;
	Force.v[2]=Z;
	
	RigidBody->SetForce(Force);
}

TESTDLL_API void __stdcall TOKRB_SetForce2(neRigidBody *RigidBody,float X,float Y,float Z,float XPos,float YPos,float ZPos)
{
	neV3 Force;
	neV3 Pos;
	Force.v[0]=X;
	Force.v[1]=Y;
	Force.v[2]=Z;
	Pos.v[0]=XPos;
	Pos.v[1]=YPos;
	Pos.v[2]=ZPos;
	
	RigidBody->SetForce(Force,Pos);
}

TESTDLL_API void __stdcall TOKRB_SetTorque(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Torque;
	Torque.v[0]=X;
	Torque.v[1]=Y;
	Torque.v[2]=Z;
	
	RigidBody->SetTorque(Torque);
}

//neV3 GetVelocity();
//void SetVelocity(const neV3 & v);
//neV3 GetAngularVelocity();
//neV3 GetAngularMomentum();
//void SetAngularMomentum(const neV3& am

TESTDLL_API void __stdcall TOKRB_SetVelocity(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Vel;
	Vel.v[0]=X;
	Vel.v[1]=Y;
	Vel.v[2]=Z;
	
	RigidBody->SetVelocity(Vel);
}

TESTDLL_API void __stdcall TOKRB_SetAngularMomentum(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Moment;
	Moment.v[0]=X;
	Moment.v[1]=Y;
	Moment.v[2]=Z;
	
	RigidBody->SetAngularMomentum(Moment);
}

TESTDLL_API float __stdcall TOKRB_GetVelocityX(neRigidBody *RigidBody)
{
	neV3 Vel;
	
	Vel = RigidBody->GetVelocity();
	return Vel.v[0];
}
TESTDLL_API float __stdcall TOKRB_GetVelocityY(neRigidBody *RigidBody)
{
	neV3 Vel;
	
	Vel = RigidBody->GetVelocity();
	return Vel.v[1];
}
TESTDLL_API float __stdcall TOKRB_GetVelocityZ(neRigidBody *RigidBody)
{
	neV3 Vel;
	
	Vel = RigidBody->GetVelocity();
	return Vel.v[2];
}

TESTDLL_API float __stdcall TOKRB_GetAngularMomentumX(neRigidBody *RigidBody)
{
	neV3 Moment;
	
	Moment = RigidBody->GetAngularMomentum();
	return Moment.v[0];
}
TESTDLL_API float __stdcall TOKRB_GetAngularMomentumY(neRigidBody *RigidBody)
{
	neV3 Moment;
	
	Moment = RigidBody->GetAngularMomentum();
	return Moment.v[1];
}
TESTDLL_API float __stdcall TOKRB_GetAngularMomentumZ(neRigidBody *RigidBody)
{
	neV3 Moment;
	
	Moment = RigidBody->GetAngularMomentum();
	return Moment.v[2];
}

TESTDLL_API float __stdcall TOKRB_GetAngularVelocityX(neRigidBody *RigidBody)
{
	neV3 Vel;
	
	Vel = RigidBody->GetAngularVelocity();
	return Vel.v[0];
}
TESTDLL_API float __stdcall TOKRB_GetAngularVelocityY(neRigidBody *RigidBody)
{
	neV3 Vel;
	
	Vel = RigidBody->GetAngularVelocity();
	return Vel.v[1];
}
TESTDLL_API float __stdcall TOKRB_GetAngularVelocityZ(neRigidBody *RigidBody)
{
	neV3 Vel;
	
	Vel = RigidBody->GetAngularVelocity();
	return Vel.v[2];
}

//	neV3	GetVelocityAtPoint(const neV3 & pt);

TESTDLL_API float __stdcall TOKRB_GetVelocityAtPointX(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Pos;
	if (RigidBody)
	{
		Pos.v[0] = X;
		Pos.v[1] = Y;
		Pos.v[2] = Z;
		return RigidBody->GetVelocityAtPoint(Pos).v[0];
	}
	return 0.0f;

}

TESTDLL_API float __stdcall TOKRB_GetVelocityAtPointY(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Pos;
	if (RigidBody)
	{
		Pos.v[0] = X;
		Pos.v[1] = Y;
		Pos.v[2] = Z;
		return RigidBody->GetVelocityAtPoint(Pos).v[1];
	}
	return 0.0f;

}

TESTDLL_API float __stdcall TOKRB_GetVelocityAtPointZ(neRigidBody *RigidBody,float X,float Y,float Z)
{
	neV3 Pos;
	if (RigidBody)
	{
		Pos.v[0] = X;
		Pos.v[1] = Y;
		Pos.v[2] = Z;
		return RigidBody->GetVelocityAtPoint(Pos).v[2];
	}
	return 0.0f;

}



TESTDLL_API void __stdcall TOKRB_Active(neRigidBody *RigidBody,int Active)
{
	neRigidBody *TempRigidBody = NULL;
	RigidBody->Active(Active,TempRigidBody);
}

TESTDLL_API int __stdcall TOKRB_IsActive(neRigidBody *RigidBody)
{
	return RigidBody->Active();
}

TESTDLL_API void __stdcall TOKRB_SetAngularDamping(neRigidBody *RigidBody,float Damping)
{
	RigidBody->SetAngularDamping(Damping);
}


TESTDLL_API void __stdcall TOKRB_SetLinearDamping(neRigidBody *RigidBody,float Damping)
{
	RigidBody->SetLinearDamping(Damping);
}

TESTDLL_API neBool __stdcall TOKRB_IsIdle(neRigidBody *RigidBody)
{
	return RigidBody->IsIdle();
}

TESTDLL_API void __stdcall TOKRB_CollideConnected(neRigidBody *RigidBody,int Collide)
{
	RigidBody->CollideConnected(Collide);
}

TESTDLL_API void __stdcall TOKRB_CollideDirectlyConnected(neRigidBody *RigidBody,int Collide)
{
	RigidBody->CollideDirectlyConnected(Collide);
}

TESTDLL_API void __stdcall TOKRB_SetSleepingParameter(neRigidBody *RigidBody,float sleepingParam)
{
		RigidBody->SetSleepingParameter(sleepingParam);
}

//void SetUserData(u32 userData);

TESTDLL_API void __stdcall TOKRB_SetUserData(neRigidBody *RigidBody,int UserData)
{
		RigidBody->SetUserData(UserData);
}

TESTDLL_API int __stdcall TOKRB_GetUserData(neRigidBody *RigidBody)
{
		return RigidBody->GetUserData();
}

//neSensor * AddSensor();
//neBool RemoveSensor(neSensor * s);
//void BeginIterateSensor();
//neSensor * GetNextSensor();
//void SetLineSensor(const neV3 & pos, const neV3 dir);

TESTDLL_API neSensor * __stdcall TOKRB_AddSensor(neRigidBody *RigidBody,float PosX,float PosY,float PosZ,float DirX,float DirY,float DirZ)
{
	neSensor *Sensor;
	neV3 pos;
	neV3 dir;

	if (gSim)
	{
		Sensor = RigidBody->AddSensor();
		pos.v[0]=PosX;
		pos.v[1]=PosY;
		pos.v[2]=PosZ;
		dir.v[0]=DirX;
		dir.v[1]=DirY;
		dir.v[2]=DirZ;

		Sensor->SetLineSensor(pos,dir);
		RigidBody->UpdateBoundingInfo();

	// Check if the rigid body has a controller...		
	RigidBody->BeginIterateController();
	if (RigidBody->GetNextController())
	{
		// Do nothing
	}
	else
	{
		RigidBody->AddController(&rbcallbackInstance, 0); // period of 0 meaning once per timestep.
	};

	//Add the sensor to the sensorbuffer
		AddSensorToBuffer(Sensor);

		return Sensor;
	}
	else 
	{
		return 0;
	}
}


TESTDLL_API void __stdcall TOKRB_RemoveSensor(neRigidBody *RigidBody,neSensor *Sensor)
{
	if (RigidBody)
	{
		if (Sensor)
		{
			RigidBody->RemoveSensor(Sensor);
			RemoveSensorFromBuffer(Sensor);
		}
	}
}


TESTDLL_API void __stdcall TOKRB_BeginIterateSensor(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		RigidBody->BeginIterateSensor();
	}
}

TESTDLL_API neSensor * __stdcall TOKRB_GetNextSensor(neRigidBody *RigidBody)
{
	if (RigidBody)
	{
		return RigidBody->GetNextSensor();
	}
	return 0;
}

TESTDLL_API void __stdcall TOKRB_GravityEnable(neRigidBody *RigidBody,int Enable)
{
	RigidBody->GravityEnable(Enable);
}

TESTDLL_API int __stdcall TOKRB_IsGravityEnabled(neRigidBody *RigidBody)
{
	return RigidBody->GravityEnable();
}



// *****************
// * ANIMATED BODY *
// *****************

TESTDLL_API neAnimatedBody * __stdcall TOKAB_Create()
{
	neAnimatedBody	*NewAnimatedBody;

	if (gSim)
	{
		NewAnimatedBody = gSim->CreateAnimatedBody();
		return NewAnimatedBody;
	}
	else
	{
		return 0;
	}
}

TESTDLL_API void __stdcall TOKAB_Free(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		// First remove all connected sensors
		neSensor * tempsensor;
		AnimatedBody->BeginIterateSensor();
		while (tempsensor = AnimatedBody->GetNextSensor())
		{
			RemoveSensorFromBuffer(tempsensor);	
		};

		gSim->FreeAnimatedBody(AnimatedBody);
	}
}

TESTDLL_API void __stdcall TOKAB_SetCollisionID(neAnimatedBody *AnimatedBody,int ColID)
{
	if (AnimatedBody)
	{
		AnimatedBody->SetCollisionID(ColID);
	}
}

TESTDLL_API int __stdcall TOKAB_GetCollisionID(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		return AnimatedBody->GetCollisionID();
	}
		return 0;	
}


TESTDLL_API neGeometry * __stdcall TOKAB_AddBox(neAnimatedBody *AnimatedBody,float Width,float Height,float Depth)
{
	neGeometry *geom;

	if (gSim)
	{
		geom = AnimatedBody->AddGeometry();
		geom->SetBoxSize(Width, Height, Depth);
		AnimatedBody->UpdateBoundingInfo();
	return geom;
	}
	else 
	{
		return 0;
	}
}

TESTDLL_API neGeometry * __stdcall TOKAB_AddSphere(neAnimatedBody *AnimatedBody,float Diameter)
{
	neGeometry *geom;

	if (gSim)
	{
		geom = AnimatedBody->AddGeometry();
		geom->SetSphereDiameter(Diameter);
		AnimatedBody->UpdateBoundingInfo();
	return geom;
	}
	else 
	{
		return 0;
	}
}

TESTDLL_API neGeometry * __stdcall TOKAB_AddCylinder(neAnimatedBody *AnimatedBody,float Diameter,float Height)
{
	neGeometry *geom;	

	if (gSim)
	{
		geom = AnimatedBody->AddGeometry();
		geom->SetCylinder(Diameter, Height);
		AnimatedBody->UpdateBoundingInfo();
	return geom;
	}
	else 
	{
		return 0;
	}
}

TESTDLL_API neGeometry * __stdcall TOKAB_AddConvex(neAnimatedBody *AnimatedBody,neByte *Bank,int BankSize)
{
	neGeometry *geom;	
	neByte *NeighbourData;
	
	if (AnimatedBody)
	{
		ReadConvexData2(Bank,BankSize, NeighbourData);
		geom = AnimatedBody->AddGeometry();
		geom->SetConvexMesh(NeighbourData);
		AnimatedBody->UpdateBoundingInfo();
		return geom;
	}
	else 
	{
		return 0;
	}
}


TESTDLL_API void __stdcall TOKAB_UpdateBoundingInfo(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		AnimatedBody->UpdateBoundingInfo();
	}
}

TESTDLL_API void __stdcall TOKAB_CollideConnected(neAnimatedBody *AnimatedBody,int Collide)
{
	AnimatedBody->CollideConnected(Collide);
}

TESTDLL_API void __stdcall TOKAB_CollideDirectlyConnected(neAnimatedBody *AnimatedBody,int Collide)
{
	AnimatedBody->CollideDirectlyConnected(Collide);
}

TESTDLL_API void __stdcall TOKAB_SetPosition(neAnimatedBody *AnimatedBody,float X,float Y,float Z)
{
	neV3 pos;
	if (AnimatedBody)
	{
		pos.Set(X , Y , Z);
		AnimatedBody->SetPos(pos);
	}
}

TESTDLL_API void __stdcall TOKAB_SetRotation(neAnimatedBody *AnimatedBody,float Pitch,float Yaw,float Roll)
{
	neM3 BodyRot;
	if (AnimatedBody)
	{
		BodyRot = EulerToMat3(Pitch,Yaw,Roll);
		AnimatedBody->SetRotation(BodyRot);
	}
}

TESTDLL_API float __stdcall TOKAB_GetX(neAnimatedBody *AnimatedBody)
{
	neV3 BodyPos;

	if (AnimatedBody)
	{
		BodyPos = AnimatedBody->GetPos();
	}
	return BodyPos.v[0];
}

TESTDLL_API float __stdcall TOKAB_GetY(neAnimatedBody *AnimatedBody)
{
	neV3 BodyPos;

	if (AnimatedBody)
	{
		BodyPos = AnimatedBody->GetPos();
	}
	return BodyPos.v[1];
}

TESTDLL_API float __stdcall TOKAB_GetZ(neAnimatedBody *AnimatedBody)
{
	neV3 BodyPos;

	if (AnimatedBody)
	{
		BodyPos = AnimatedBody->GetPos();
	}
	return BodyPos.v[2];
}

TESTDLL_API float __stdcall TOKAB_GetPitch(neAnimatedBody *AnimatedBody)
{
	neV3 Euler;
	Euler = Mat3ToEulerZXY(AnimatedBody->GetRotationM3());
	return -NE_RAD_TO_DEG(Euler.v[0]);
}
TESTDLL_API float __stdcall TOKAB_GetYaw(neAnimatedBody *AnimatedBody)
{
	neV3 Euler;
	Euler = Mat3ToEulerZXY(AnimatedBody->GetRotationM3());
	return NE_RAD_TO_DEG(Euler.v[1]);
}
TESTDLL_API float __stdcall TOKAB_GetRoll(neAnimatedBody *AnimatedBody)
{
	neV3 Euler;
	Euler = Mat3ToEulerZXY(AnimatedBody->GetRotationM3());
	return -NE_RAD_TO_DEG(Euler.v[2]);
}

TESTDLL_API void __stdcall TOKAB_RemoveGeometry(neAnimatedBody *AnimatedBody,neGeometry *Geom)
{
	if (AnimatedBody)
	{
		if (Geom)
		{
			AnimatedBody->RemoveGeometry(Geom);
		}
	}
}

TESTDLL_API int __stdcall TOKAB_GetGeometryCount(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		return AnimatedBody->GetGeometryCount();
	}
	return 0;
}

TESTDLL_API void __stdcall TOKAB_BeginIterateGeometry(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		AnimatedBody->BeginIterateGeometry();
	}
}

TESTDLL_API neGeometry * __stdcall TOKAB_GetNextGeometry(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		return AnimatedBody->GetNextGeometry();
	}
	return 0;
}


TESTDLL_API void __stdcall TOKAB_SetUserData(neAnimatedBody *AnimatedBody,int UserData)
{
		AnimatedBody->SetUserData(UserData);
}

TESTDLL_API int __stdcall TOKAB_GetUserData(neAnimatedBody *AnimatedBody)
{
		return AnimatedBody->GetUserData();
}

/*TESTDLL_API neSensor * __stdcall TOKAB_AddSensor(neAnimatedBody *AnimatedBody,float PosX,float PosY,float PosZ,float DirX,float DirY,float DirZ)
{
	neSensor *Sensor;
	neV3 pos;
	neV3 dir;

	if (gSim)
	{
		Sensor = AnimatedBody->AddSensor();
		pos.v[0]=PosX;
		pos.v[1]=PosY;
		pos.v[2]=PosZ;
		dir.v[0]=DirX;
		dir.v[1]=DirY;
		dir.v[2]=DirZ;

		Sensor->SetLineSensor(pos,dir);
		AnimatedBody->UpdateBoundingInfo();
		AddSensorToBuffer(Sensor);

		return Sensor;
	}
	else 
	{
		return 0;
	}
}


TESTDLL_API void __stdcall TOKAB_RemoveSensor(neAnimatedBody *AnimatedBody,neSensor *Sensor)
{
	if (AnimatedBody)
	{
		if (Sensor)
		{
			AnimatedBody->RemoveSensor(Sensor);
			RemoveSensorFromBuffer(Sensor);
		}
	}
}


TESTDLL_API void __stdcall TOKAB_BeginIterateSensor(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		AnimatedBody->BeginIterateSensor();
	}
}

TESTDLL_API neSensor * __stdcall TOKAB_GetNextSensor(neAnimatedBody *AnimatedBody)
{
	if (AnimatedBody)
	{
		return AnimatedBody->GetNextSensor();
	}
	return 0;
}
*/


// ************
// * GEOMETRY *
// ************

TESTDLL_API void __stdcall TOKGEOM_SetPositionAndRotation(neGeometry *Geom,float X,float Y,float Z,float Pitch,float Yaw,float Roll)
{
	neT3 Transform;

	if (Geom)
	{
	Transform.pos.v[0] = X;
	Transform.pos.v[1] = Y;
	Transform.pos.v[2] = Z;
	Transform.pos.v[3] = 0;
	Transform.rot = EulerToMat3(Pitch,Yaw,Roll);
	Geom->SetTransform(Transform);
	}
}

TESTDLL_API void __stdcall TOKGEOM_SetMaterialIndex(neGeometry *Geom,int Index)
{
	if (Geom)
	{
		Geom->SetMaterialIndex(Index);
	}
}

TESTDLL_API int __stdcall TOKGEOM_GetMaterialIndex(neGeometry *Geom)
{
	if (Geom)
	{
		return Geom->GetMaterialIndex();
	}
		return -1;
}

TESTDLL_API void __stdcall TOKGEOM_SetUserData(neGeometry *Geom,int UserData)
{
		Geom->SetUserData(UserData);
}

TESTDLL_API int __stdcall TOKGEOM_GetUserData(neGeometry *Geom)
{
		return Geom->GetUserData();
}




// **********
// * JOINTS *
// **********

TESTDLL_API neJoint * __stdcall TOKJOINT_Create(int ConnectionType,void *BodyA,void *BodyB)
{
// ConnectionTypes:
// 1 = RigidBody to World
// 2 = RigidBody to RigidBody
// 3 = RigidBody to AnimatedBody
		neJoint *NewJoint;
		neRigidBody *RigidBodyA;
		neRigidBody *RigidBodyB;
		neAnimatedBody *AnimatedBody;

		if (ConnectionType==1)
		{
			RigidBodyA = (neRigidBody *)BodyA;
			NewJoint = gSim->CreateJoint(RigidBodyA);
		}
		else if (ConnectionType==2)
		{
			RigidBodyA = (neRigidBody *)BodyA;
			RigidBodyB = (neRigidBody *)BodyB;
			NewJoint = gSim->CreateJoint(RigidBodyA,RigidBodyB);
		}
		else if (ConnectionType==3)
		{
			RigidBodyA = (neRigidBody *)BodyA;
			AnimatedBody = (neAnimatedBody *)BodyB;
			NewJoint = gSim->CreateJoint(RigidBodyA,AnimatedBody);
		}
		return NewJoint;
}

TESTDLL_API void __stdcall TOKJOINT_Free(neJoint *Joint)
{
	if (Joint)
	{
		gSim->FreeJoint(Joint);
	}
}


TESTDLL_API void __stdcall TOKJOINT_SetType(neJoint *Joint,int JointType)
{
	if (Joint)
	{
		if (JointType==1) 
		{
			Joint->SetType(neJoint::NE_JOINT_BALLSOCKET);
		}
		else if (JointType==2)
		{
			Joint->SetType(neJoint::NE_JOINT_BALLSOCKET2);
		}
		else if (JointType==3)
		{
			Joint->SetType(neJoint::NE_JOINT_HINGE);
		}
		else if (JointType==4)
		{
			Joint->SetType(neJoint::NE_JOINT_SLIDE);
		}
		
//		Joint->Enable(true);
	}
}

TESTDLL_API void __stdcall TOKJOINT_Enable(neJoint *Joint,int Enabled)
{
	if (Joint)
	{
		Joint->Enable(Enabled);
	}
}

TESTDLL_API int __stdcall TOKJOINT_IsEnabled(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->Enable();
	}
	return 0;
}


TESTDLL_API void __stdcall TOKJOINT_SetPositionWorld(neJoint *Joint,float X,float Y,float Z,float Pitch,float Yaw,float Roll)
{
	neT3 Transform;
	
	if (Joint)
	{
		Transform.pos.v[0] = X;
		Transform.pos.v[1] = Y;
		Transform.pos.v[2] = Z;
		Transform.pos.v[3] = 0;
		Transform.rot = EulerToMat3(Pitch,Yaw,Roll);
		Joint->SetJointFrameWorld(Transform);
	}
}

TESTDLL_API void __stdcall TOKJOINT_SetPositionFrameA(neJoint *Joint,float X,float Y,float Z,float Pitch,float Yaw,float Roll)
{
	neT3 Transform;
	
	if (Joint)
	{
		Transform.pos.v[0] = X;
		Transform.pos.v[1] = Y;
		Transform.pos.v[2] = Z;
		Transform.pos.v[3] = 0;
		Transform.rot = EulerToMat3(Pitch,Yaw,Roll);
		Joint->SetJointFrameA(Transform);
	}
}

TESTDLL_API void __stdcall TOKJOINT_SetPositionFrameB(neJoint *Joint,float X,float Y,float Z,float Pitch,float Yaw,float Roll)
{
	neT3 Transform;
	
	if (Joint)
	{
		Transform.pos.v[0] = X;
		Transform.pos.v[1] = Y;
		Transform.pos.v[2] = Z;
		Transform.pos.v[3] = 0;
		Transform.rot = EulerToMat3(Pitch,Yaw,Roll);
		Joint->SetJointFrameB(Transform);
	}
}

TESTDLL_API float __stdcall TOKJOINT_GetFrameAX(neJoint *Joint)
{
	neV3 Position;
	if (Joint)
	{
	Position = Joint->GetJointFrameA().pos;
	return Position.v[0];
	} 
	return 0.0f;
}

TESTDLL_API float __stdcall TOKJOINT_GetFrameAY(neJoint *Joint)
{
	neV3 Position;
	if (Joint)
	{
	Position = Joint->GetJointFrameA().pos;
	return Position.v[1];
	} 
	return 0.0f;
}

TESTDLL_API float __stdcall TOKJOINT_GetFrameAZ(neJoint *Joint)
{
	neV3 Position;
	if (Joint)
	{
	Position = Joint->GetJointFrameA().pos;
	return Position.v[2];
	} 
	return 0.0f;
}

TESTDLL_API float __stdcall TOKJOINT_GetFrameBX(neJoint *Joint)
{
	neV3 Position;
	if (Joint)
	{
	Position = Joint->GetJointFrameB().pos;
	return Position.v[0];
	} 
	return 0.0f;
}

TESTDLL_API float __stdcall TOKJOINT_GetFrameBY(neJoint *Joint)
{
	neV3 Position;
	if (Joint)
	{
	Position = Joint->GetJointFrameB().pos;
	return Position.v[1];
	} 
	return 0.0f;
}

TESTDLL_API float __stdcall TOKJOINT_GetFrameBZ(neJoint *Joint)
{
	neV3 Position;
	if (Joint)
	{
	Position = Joint->GetJointFrameB().pos;
	return Position.v[2];
	} 
	return 0.0f;
}


TESTDLL_API float __stdcall TOKJOINT_GetFrameAPitch(neJoint *Joint)
{
	neV3 Euler;

	if (Joint)
	{
	Euler = Mat3ToEulerZXY(Joint->GetJointFrameA().rot);
	return -NE_RAD_TO_DEG(Euler.v[0]);
	} 
	return 0.0f;
}


TESTDLL_API float __stdcall TOKJOINT_GetFrameAYaw(neJoint *Joint)
{
	neV3 Euler;

	if (Joint)
	{
	Euler = Mat3ToEulerZXY(Joint->GetJointFrameA().rot);
	return NE_RAD_TO_DEG(Euler.v[1]);
	} 
	return 0.0f;
}


TESTDLL_API float __stdcall TOKJOINT_GetFrameARoll(neJoint *Joint)
{
	neV3 Euler;

	if (Joint)
	{
	Euler = Mat3ToEulerZXY(Joint->GetJointFrameA().rot);
	return -NE_RAD_TO_DEG(Euler.v[2]);
	} 
	return 0.0f;
}

TESTDLL_API float __stdcall TOKJOINT_GetFrameBPitch(neJoint *Joint)
{
	neV3 Euler;

	if (Joint)
	{
	Euler = Mat3ToEulerZXY(Joint->GetJointFrameB().rot);
	return -NE_RAD_TO_DEG(Euler.v[0]);
	} 
	return 0.0f;
}


TESTDLL_API float __stdcall TOKJOINT_GetFrameBYaw(neJoint *Joint)
{
	neV3 Euler;

	if (Joint)
	{
	Euler = Mat3ToEulerZXY(Joint->GetJointFrameB().rot);
	return NE_RAD_TO_DEG(Euler.v[1]);
	} 
	return 0.0f;
}


TESTDLL_API float __stdcall TOKJOINT_GetFrameBRoll(neJoint *Joint)
{
	neV3 Euler;

	if (Joint)
	{
	Euler = Mat3ToEulerZXY(Joint->GetJointFrameB().rot);
	return -NE_RAD_TO_DEG(Euler.v[2]);
	} 
	return 0.0f;
}

TESTDLL_API void __stdcall TOKJOINT_SetJointLength(neJoint *Joint,float Length)
{
	if (Joint)
	{
		Joint->SetJointLength(Length);
	}
}

TESTDLL_API float __stdcall TOKJOINT_GetJointLength(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetJointLength();
	}
	else
		return 0.0f;
}


TESTDLL_API void __stdcall TOKJOINT_SetUpperLimit(neJoint *Joint,float Limit)
{
	if (Joint)
	{
		Joint->SetUpperLimit(Limit);
	}
}

TESTDLL_API void __stdcall TOKJOINT_SetLowerLimit(neJoint *Joint,float Limit)
{
	if (Joint)
	{
		Joint->SetLowerLimit(Limit);
	}
}
TESTDLL_API void __stdcall TOKJOINT_SetUpperLimit2(neJoint *Joint,float Limit)
{
	if (Joint)
	{
		Joint->SetUpperLimit2(Limit);
	}
}
TESTDLL_API void __stdcall TOKJOINT_SetLowerLimit2(neJoint *Joint,float Limit)
{
	if (Joint)
	{
		Joint->SetLowerLimit2(Limit);
	}
}
TESTDLL_API float __stdcall TOKJOINT_GetUpperLimit(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetUpperLimit();
	}
	else
		return 0.0f;
}
TESTDLL_API float __stdcall TOKJOINT_GetLowerLimit(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetLowerLimit();
	}
	else
		return 0.0f;
}
TESTDLL_API float __stdcall TOKJOINT_GetUpperLimit2(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetUpperLimit2();
	}
	else
		return 0.0f;
}
TESTDLL_API float __stdcall TOKJOINT_GetLowerLimit2(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetLowerLimit2();
	}
	else
		return 0.0f;
}

TESTDLL_API void __stdcall TOKJOINT_EnableLimit(neJoint *Joint,int Enabled)
{
	if (Joint)
	{
		Joint->EnableLimit(Enabled);
	}
}

TESTDLL_API void __stdcall TOKJOINT_EnableLimit2(neJoint *Joint,int Enabled)
{
	if (Joint)
	{
		Joint->EnableLimit2(Enabled);
	}
}

TESTDLL_API int __stdcall TOKJOINT_IsLimitEnabled(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->EnableLimit();
	}
	else
		return 0;
}

TESTDLL_API int __stdcall TOKJOINT_IsLimit2Enabled(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->EnableLimit2();
	}
	else
		return 0;
}

//void SetEpsilon(f32 e);
//f32 GetEpsilon();
//void SetIteration(s32 i);
//s32 GetIteration();

TESTDLL_API void __stdcall TOKJOINT_SetEpsilon(neJoint *Joint,float Epsilon)
{
	if (Joint)
	{
		Joint->SetEpsilon(Epsilon);
	}
}

TESTDLL_API void __stdcall TOKJOINT_SetIterations(neJoint *Joint,int Iterations)
{
	if (Joint)
	{
		Joint->SetIteration(Iterations);
	}
}

TESTDLL_API float __stdcall TOKJOINT_GetEpsilon(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetEpsilon();
	}
		return 0.0f;
}

TESTDLL_API int __stdcall TOKJOINT_GetIterations(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetIteration();
	}
		return 0;
}

TESTDLL_API void __stdcall TOKJOINT_SetDampingFactor(neJoint *Joint,float Damping)
{
	if (Joint)
	{
		Joint->SetDampingFactor(Damping);
	}
}

TESTDLL_API float __stdcall TOKJOINT_GetDampingFactor(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->GetDampingFactor();
	}
	return 0.0f;
}

//	neBool EnableMotor();
//	void EnableMotor(neBool yes);
//	void SetMotor(MotorType motorType, f32 desireValue, f32 maxForce);

TESTDLL_API int __stdcall TOKJOINT_IsMotorEnabled(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->EnableMotor();
	}
	else
	{
		return 0;
	}
}

TESTDLL_API void __stdcall TOKJOINT_EnableMotor(neJoint *Joint,int Enabled)
{
	if (Joint)
	{
		Joint->EnableMotor(Enabled);
	}
}

TESTDLL_API void __stdcall TOKJOINT_SetMotorSpeed(neJoint *Joint,float DesiredForce, float MaxForce)
{
	if (Joint)
	{
		Joint->SetMotor(neJoint::NE_MOTOR_SPEED,DesiredForce,MaxForce);
	}
}

TESTDLL_API int __stdcall TOKJOINT_IsMotor2Enabled(neJoint *Joint)
{
	if (Joint)
	{
		return Joint->EnableMotor2();
	}
	else
	{
		return 0;
	}
}

TESTDLL_API void __stdcall TOKJOINT_EnableMotor2(neJoint *Joint,int Enabled)
{
	if (Joint)
	{
		Joint->EnableMotor2(Enabled);
	}
}

TESTDLL_API void __stdcall TOKJOINT_SetMotor2Speed(neJoint *Joint,float DesiredForce, float MaxForce)
{
	if (Joint)
	{
		Joint->SetMotor2(neJoint::NE_MOTOR_SPEED,DesiredForce,MaxForce);
	}
}

// ***********
// * TERRAIN *
// ***********

TESTDLL_API void __stdcall TOKSIM_SetStaticMesh(neV3 *Vertices,int VertexCount,neTriangle *Triangles,int TriangleCount)
{
	neTriangleMesh tris;

	tris.vertices = Vertices;
	tris.vertexCount = VertexCount;
	tris.triangles = Triangles;
	tris.triangleCount = TriangleCount;

	gSim->SetTerrainMesh(&tris);

}

TESTDLL_API void __stdcall TOKSIM_FreeStaticMesh()
{
	gSim->FreeTerrainMesh();
}

// ************
// * PARTICLE *
// ************

TESTDLL_API neRigidBody * __stdcall TOKRB_CreateParticle()
{
	neRigidBody *NewRigidBody;

	if (gSim)
	{
		NewRigidBody = gSim->CreateRigidParticle();
		return NewRigidBody;
	}
	else 
	{
		return 0;
	}
}

// **********
// * SENSOR *
// **********

//void SetLineSensor(const neV3 & pos, const neV3 dir);
//neV3 GetLineVector();
//neV3 GetLineUnitVector();
//neV3 GetLinePos();
//void SetUserData(u32 userData);
//u32 GetUserData();

TESTDLL_API void __stdcall TOKSENSOR_SetLineSensor(neSensor *Sensor,float PosX,float PosY,float PosZ,float DirX,float DirY,float DirZ)
{
	neV3 pos;
	neV3 dir;

	if (Sensor)
	{
		pos.v[0]=PosX;
		pos.v[1]=PosY;
		pos.v[2]=PosZ;
		dir.v[0]=DirX;
		dir.v[1]=DirY;
		dir.v[2]=DirZ;

		Sensor->SetLineSensor(pos,dir);
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLineVectorX(neSensor *Sensor)
{
	neV3 Vector;
	if (Sensor)
	{
		Vector = Sensor->GetLineVector();
		return Vector.v[0];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLineVectorY(neSensor *Sensor)
{
	neV3 Vector;
	if (Sensor)
	{
		Vector = Sensor->GetLineVector();
		return Vector.v[1];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLineVectorZ(neSensor *Sensor)
{
	neV3 Vector;
	if (Sensor)
	{
		Vector = Sensor->GetLineVector();
		return Vector.v[2];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLineUnitVectorX(neSensor *Sensor)
{
	neV3 Vector;
	if (Sensor)
	{
		Vector = Sensor->GetLineUnitVector();
		return Vector.v[0];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLineUnitVectorY(neSensor *Sensor)
{
	neV3 Vector;
	if (Sensor)
	{
		Vector = Sensor->GetLineUnitVector();
		return Vector.v[1];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLineUnitVectorZ(neSensor *Sensor)
{
	neV3 Vector;
	if (Sensor)
	{
		Vector = Sensor->GetLineUnitVector();
		return Vector.v[2];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLinePosX(neSensor *Sensor)
{
	neV3 Pos;
	if (Sensor)
	{
		Pos = Sensor->GetLinePos();
		return Pos.v[0];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLinePosY(neSensor *Sensor)
{
	neV3 Pos;
	if (Sensor)
	{
		Pos = Sensor->GetLinePos();
		return Pos.v[1];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API float __stdcall TOKSENSOR_GetLinePosZ(neSensor *Sensor)
{
	neV3 Pos;
	if (Sensor)
	{
		Pos = Sensor->GetLinePos();
		return Pos.v[2];
	}
	else
	{
		return 0.0f;
	}
}

TESTDLL_API void __stdcall TOKSENSOR_SetInfoBank(neSensor *Sensor,int Bank)
{
		Sensor->SetUserData(Bank);
}



TESTDLL_API void __stdcall TOKSENSOR_SetUserData(neSensor *Sensor,int UserData)
{
		Sensor->SetUserData(UserData);
}

TESTDLL_API int __stdcall TOKSENSOR_GetUserData(neSensor *Sensor)
{
		return Sensor->GetUserData();
}

TESTDLL_API float __stdcall TOKSENSOR_GetDetectDepth(neSensor *Sensor)
{
	int i;
	int * intptr;
	float * floatptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			floatptr = (float *)intptr;
			floatptr+=1;
			return *floatptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};
		return -1.0f;

}


TESTDLL_API float __stdcall TOKSENSOR_GetDetectNormalX(neSensor *Sensor)
{
	int i;
	int * intptr;
	float * floatptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			floatptr = (float *)intptr;
			floatptr+=2;
			return *floatptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};
		return -1.0f;


}

TESTDLL_API float __stdcall TOKSENSOR_GetDetectNormalY(neSensor *Sensor)
{
	int i;
	int * intptr;
	float * floatptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			floatptr = (float *)intptr;
			floatptr+=3;
			return *floatptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};
		return -1.0f;

}

TESTDLL_API float __stdcall TOKSENSOR_GetDetectNormalZ(neSensor *Sensor)
{
	int i;
	int * intptr;
	float * floatptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			floatptr = (float *)intptr;
			floatptr+=4;
			return *floatptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};
		return -1.0f;
}

TESTDLL_API float __stdcall TOKSENSOR_GetDetectContactPointX(neSensor *Sensor)
{
	int i;
	int * intptr;
	float * floatptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			floatptr = (float *)intptr;
			floatptr+=5;
			return *floatptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};
		return -1.0f;
}

TESTDLL_API float __stdcall TOKSENSOR_GetDetectContactPointY(neSensor *Sensor)
{
	int i;
	int * intptr;
	float * floatptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			floatptr = (float *)intptr;
			floatptr+=6;
			return *floatptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};
		return -1.0f;
}

TESTDLL_API float __stdcall TOKSENSOR_GetDetectContactPointZ(neSensor *Sensor)
{
	int i;
	int * intptr;
	float * floatptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			floatptr = (float *)intptr;
			floatptr+=7;
			return *floatptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};
		return -1.0f;
}

TESTDLL_API neRigidBody * __stdcall TOKSENSOR_GetDetectRigidBody(neSensor *Sensor)
{
	int i;
	int * intptr;
	int * intptr2;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			intptr2 = intptr;
			intptr2+=8;
			return (neRigidBody *)*intptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+10;
		};
	};
		return 0;
}

TESTDLL_API neAnimatedBody * __stdcall TOKSENSOR_GetDetectAnimatedBody(neSensor *Sensor)
{
	int i;
	int * intptr;
	int * intptr2;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			intptr2 = intptr;
			intptr2+=9;
			return (neAnimatedBody *)*intptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+10;
		};
	};
		return 0;
}

TESTDLL_API int __stdcall TOKSENSOR_GetDetectMaterial(neSensor *Sensor)
{
	int i;
	int * intptr;
	int * intptr2;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor 
			intptr2 = intptr;
			intptr2+=10;
			return *intptr;
		}
		else
		{
			// Keep looking
			intptr=intptr+10;
		};
	};
		return -1;
}

// ********************
// * Helper functions *
// ********************


neV3 Mat3ToEulerZXY(neM3 Matrix)
{
	float m_afEntry[9];
	float rfXAngle;
	float rfYAngle;
	float rfZAngle;

	neV3 Result;
	
	m_afEntry[0] = Matrix.M[0].v[0];
	m_afEntry[1] = Matrix.M[0].v[1];
	m_afEntry[2] = Matrix.M[0].v[2];
	m_afEntry[3] = Matrix.M[1].v[0];
	m_afEntry[4] = Matrix.M[1].v[1];
	m_afEntry[5] = Matrix.M[1].v[2];
	m_afEntry[6] = Matrix.M[2].v[0];
	m_afEntry[7] = Matrix.M[2].v[1];
	m_afEntry[8] = Matrix.M[2].v[2];


    if ( m_afEntry[7] < 1.0f )
    {
        if ( m_afEntry[7] > -1.0f )
        {
           rfZAngle = (float)atan2(-m_afEntry[1],m_afEntry[4]);
           rfXAngle = (float)asin((double)m_afEntry[7]);
           rfYAngle = (float)atan2(-m_afEntry[6],m_afEntry[8]);
			Result.v[0] = rfXAngle;
			Result.v[1] = rfYAngle;
			Result.v[2] = rfZAngle;
            return Result;
        }
        else
        {
            // WARNING.  Not unique.  ZA - YA = -atan(r02,r00)
            rfZAngle = (float)-atan2(m_afEntry[2],m_afEntry[0]);
            rfXAngle = -1.570796f;
            rfYAngle = 0.0f;
			Result.v[0] = rfXAngle;
			Result.v[1] = rfYAngle;
			Result.v[2] = rfZAngle;
            return Result;
        }
    }
    else
    {
        // WARNING.  Not unique.  ZA + YA = atan2(r02,r00)
			rfZAngle = (float)atan2(m_afEntry[2],m_afEntry[0]);
			rfXAngle = 1.570796f;
			rfYAngle = 0.0f;
			Result.v[0] = rfXAngle;
			Result.v[1] = rfYAngle;
			Result.v[2] = rfZAngle;
            return Result;
    }
}


neM3 EulerToMat3(float Pitch,float Yaw,float Roll)
{
	neQ BodyRot;
	
	float cr;
	float cp;
	float cy;
	float sr;
	float sp;
	float sy;
	float cpcy;
	float spsy;
	float spcy;
	float cpsy;
	
		cr = (float)cos(NE_DEG_TO_RAD(Roll/2.0f));
		cp = (float)cos(NE_DEG_TO_RAD(Pitch/2.0f));
		cy = (float)cos(NE_DEG_TO_RAD(-Yaw/2.0f));
		sr = (float)sin(NE_DEG_TO_RAD(Roll/2.0f));
		sp = (float)sin(NE_DEG_TO_RAD(Pitch/2.0f));
		sy = (float)sin(NE_DEG_TO_RAD(-Yaw/2.0f));
		cpcy = cp*cy;
		spsy = sp*sy;
		spcy = sp*cy;
		cpsy = cp*sy;

		BodyRot.W = (cr*cpcy)+(sr*spsy);
		BodyRot.X = (cr*spcy)+(sr*cpsy);
		BodyRot.Y = (cr*cpsy)-(sr*spcy);
		BodyRot.Z = (sr*cpcy)-(cr*spsy);
		//RigidBody->SetRotation(BodyRot);
		return BodyRot.BuildMatrix3();
		
}

void AddSensorToBuffer(neSensor * Sensor)
{
	// Check the buffer for a free slot
	int i;
	int * intptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==0)
		{
			// Found a free slot, add the sensor here
			*intptr=(int)Sensor;
			return;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};

}

void AddSensorDataToBuffer(neSensor * Sensor)
{
	neV3 Vec3;
	int i;
	int * intptr;
	float * floatptr;
	int * intptr2;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor
			floatptr = (float *)intptr;
			floatptr+=1;

			*floatptr = Sensor->GetDetectDepth();
			floatptr+=1;

			Vec3 = Sensor->GetDetectNormal();
			*floatptr = Vec3.v[0];
			floatptr+=1;

			*floatptr = Vec3.v[1];
			floatptr+=1;

			*floatptr = Vec3.v[2];
			floatptr+=1;

			Vec3 = Sensor->GetDetectContactPoint();
			*floatptr = Vec3.v[0];
			floatptr+=1;

			*floatptr = Vec3.v[1];
			floatptr+=1;

			*floatptr = Vec3.v[2];
			floatptr+=1;
			intptr2 = (int *)floatptr;

			*intptr2 = (int)Sensor->GetDetectRigidBody();
			intptr2+=1;

			*intptr2 = (int)Sensor->GetDetectAnimatedBody();
			intptr2+=1;

			*intptr2 = Sensor->GetDetectMaterial();
			return;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};

}


void RemoveSensorFromBuffer(neSensor * Sensor)
{
	// Search the buffer to find the sensor
	int i;
	int * intptr;

	intptr = (int *)SensorBuffer;
	for(i=0;i<sizeInfo.sensorsCount;i++)
	{
		if(*intptr==(int)Sensor)
		{
			// Found the sensor, "remove" it
			*intptr=0;
		}
		else
		{
			// Keep looking
			intptr=intptr+11;
		};
	};

}

struct DCDFace
{
	neByte *neighbourFaces;
	neByte *neighbourVerts;
	neByte *neighbourEdges;
};

struct DCDVert
{
	neByte * neighbourEdges;
};

struct DCDEdge
{
	neByte f1;
	neByte f2;
	neByte v1;
	neByte v2;
};

bool ReadConvexData(char * filename, neByte *& adjacency)
{
	FILE * ff =	fopen(filename, "r");

	if (ff == NULL)
		return false;

	fseek(ff, 0, SEEK_END);
	
	fpos_t pos ;

	fgetpos(ff, &pos);

	fclose(ff);

	ff = fopen(filename, "rb");

	neByte * d = new neByte[pos];

	//fseek(ff, 0, SEEK_SET);

	int r = fread(d,1, pos, ff);

	fclose(ff);

	s32 numFaces = *(int*)d;

	s32 numVerts = *((int*)d + 1);

	s32 numEdges = *((int*)d + 2);

	DCDFace * f = (DCDFace *)(d + sizeof(int) * 4 + numFaces * sizeof(f32) * 4 + numVerts * sizeof(f32) * 4);

	DCDVert * v = (DCDVert *)(f + numFaces);

	for (s32 i  = 0; i < numFaces; i++)
	{
		f[i].neighbourEdges += (int)d;
		f[i].neighbourVerts += (int)d;
		f[i].neighbourFaces += (int)d;
	}
	for (i = 0; i < numVerts; i++)
	{
		v[i].neighbourEdges += (int)d;
	}
	adjacency = d;
	
	DCDEdge * e = (DCDEdge*)(&v[numVerts]);

	int diff = (neByte*)e - d;
	return true;
}

bool ReadConvexData2(neByte *Bank,int BankSize, neByte *& adjacency)
{
	neByte * d = new neByte[BankSize];

	memcpy(d,Bank,BankSize);

	s32 numFaces = *(int*)d;

	s32 numVerts = *((int*)d + 1);

	s32 numEdges = *((int*)d + 2);

	DCDFace * f = (DCDFace *)(d + sizeof(int) * 4 + numFaces * sizeof(f32) * 4 + numVerts * sizeof(f32) * 4);

	DCDVert * v = (DCDVert *)(f + numFaces);

	for (s32 i  = 0; i < numFaces; i++)
	{
		f[i].neighbourEdges += (int)d;
		f[i].neighbourVerts += (int)d;
		f[i].neighbourFaces += (int)d;
	}
	for (i = 0; i < numVerts; i++)
	{
		v[i].neighbourEdges += (int)d;
	}
	adjacency = d;
	
	DCDEdge * e = (DCDEdge*)(&v[numVerts]);

	int diff = (neByte*)e - d;
	return true;
}
